#include <SoftwareSerial.h>
#include "iic.h"
#include "wifi.h"
#include <HardwareTimer.h>


HardwareTimer userHardwareTimer(TIM6);
SoftwareSerial mySerial(0, 1); // RX, TX
#define _SS_MAX_RX_BUFF 300
#define led_w  9
#define led_c  5
#define delay_en    1

int time_cnt = 0, cnt = 0, init_flag = 0, key_cnt = 0;
char a =0;

void setup() {
  pinMode(PC13, INPUT);     //按键检测初始化
  mySerial.begin(9600);     //软件串口初始化
  mySerial.println("myserial init successful!");
  Serial.begin(115200);     //PA3 RX   PA2 TX
  Serial.println("serial init successful!\r\n");
  light_data_int();
  IIC_Init();
  delay(10);
  rgb_init(0, 0, 0);
  timer_init();
  wifi_protocol_init();
  Hue_shade_start(&a);

}

void loop() {
  if (init_flag == 0) {
    time_cnt++;
    if (time_cnt % 5000 == 0) {
      time_cnt = 0;
      cnt ++;
    }
    wifi_stat_led(&cnt);  //配网状态指示灯
  }

  wifi_uart_service();
  myserialEvent();      //串口接收处理函数
  key_scan();           //按键重置配网

}

void myserialEvent() {
  if (mySerial.available()) {
    unsigned char ch = (unsigned char)mySerial.read();
    uart_receive_input(ch);
  }
}

void key_scan(void)
{
  static char ap_ez_change = 0;
  unsigned char buttonState  = HIGH;
  buttonState = digitalRead(PC13);
  if (buttonState == LOW) {
#if delay_en
    delay(2000);
#else
    key_cnt ++ ;
    if (key_cnt > 30000)
    {
      key_cnt = 0;
#endif
    buttonState = digitalRead(PC13);
    if (buttonState == LOW) {
      printf("123\r\n");
      init_flag = 0;
      switch (ap_ez_change) {
        case 0 :
          mcu_set_wifi_mode(SMART_CONFIG);
          break;
        case 1 :
          mcu_set_wifi_mode(AP_CONFIG);
          break;
        default:
          break;
      }
      analogWrite(led_w, 0);
      analogWrite(led_c, 0);
      rgb_init(0, 0, 0);
      ap_ez_change = !ap_ez_change;
    }
#if !delay_en
  }
#endif
}

}

void wifi_stat_led(int *cnt)
{
  switch (mcu_get_wifi_work_state())
  {
    case SMART_CONFIG_STATE:  //0x00
      init_flag = 0;
      if (*cnt == 2) {
        *cnt = 0;
      }
      if (*cnt % 2 == 0)  //LED快闪
      {
        analogWrite(led_w, 1);
      }
      else
      {
        analogWrite(led_w, 0);
      }
      break;
    case AP_STATE:  //0x01
      init_flag = 0;
      if (*cnt >= 30) {
        *cnt = 0;
      }

      if (*cnt  == 0)      //LED慢闪
      {
        analogWrite(led_w, 1);
      }
      else if (*cnt == 15)
      {
        analogWrite(led_w, 0);
      }

      break;

    case WIFI_NOT_CONNECTED:  //0x02
      analogWrite(led_w, 0); //LED熄灭
      break;
    case WIFI_CONNECTED:  //0x03
      break;
    case WIFI_CONN_CLOUD:  //0x04
      if ( 0 == init_flag )
      {
        analogWrite(led_w, 1); //LED常亮
        init_flag = 1;
        *cnt = 0;
      }
      break;

    default:
      analogWrite(led_w, 0);
      break;
  }
}
